/*
** $Id: binop_i32vi32_vi32.S,v 1.1 1996/01/05 00:30:48 davidj Exp $
**
** A general 32 bit scalar/vector binary operation routine, plus
** some instantiations
** davidj - Sat Oct 15 18:50:22 1994
*/

#include "tor/tordef.h"


/****************************************************************/

#ifdef DECL_tor_sub_i32vi32_vi32
void tor_sub_i32vi32_vi32(size_t len, intv_int32_t a, const intv_int32_t* b,
			  intv_int32_t* res);
#endif

#ifdef DEFN_tor_sub_i32vi32_vi32
#define RTNNAME tor_sub_i32vi32_vi32
#define OP_SV subu.sv
#endif

/****************************************************************/

#ifdef DECL_tor_satsub_i32vi32_vi32
void tor_satsub_i32vi32_vi32(size_t len, intv_int32_t a, const intv_int32_t* b,
			     intv_int32_t* res);
#endif

#ifdef DEFN_tor_satsub_i32vi32_vi32
#define RTNNAME tor_satsub_i32vi32_vi32
#define OP_SV ssub.sv
#endif

/****************************************************************/

/*
** This routine requires 2 macros to be defined
**
** RTNNAME - the name this routine will be known by
** OP_SV - the binary scalar-vector op to perform
*/ 

#ifndef RTNNAME
	.err
#endif
#ifndef OP_SV
	.err
#endif

	.globl	RTNNAME


#define	b_v		vv1
#define res_v		vv2

#define len_r		a0
#define a_r		a1
#define bptr_r		a2
#define resptr_r	a3

#define fourvlr_r	t0
#define done_r		t1


	.ent	RTNNAME
RTNNAME:
 # Check the length - jump forward if > 32

        .set    noreorder
        bgtu    len_r, MAXVLEN, morethan32
        ctvu    len_r, vlr              # Assume len <= 32
        .set    reorder

 # The short case (len<=32) follows directly for better cache performance

        lw.v	b_v, bptr_r
	OP_SV	res_v, a_r, b_v
	sw.v	res_v, resptr_r
	j	ra
	
 # The len>32 case

morethan32:
	li	v0, MAXVLEN
	ctvu	v0, vlr
	lw.v	b_v, bptr_r
	li	fourvlr_r, MAXVLEN*4
	add	bptr_r, fourvlr_r
	OP_SV	res_v, a_r, b_v

loop:
	lwai.v	b_v, bptr_r, fourvlr_r
	swai.v	res_v, resptr_r, fourvlr_r
	subu	len_r, MAXVLEN
 	sltu	done_r, len_r, MAXVLEN+1
	OP_SV	res_v, a_r, b_v
	beqz	done_r, loop

 # Wind up after the loop

	ctvu	len_r, vlr
	sw.v	res_v, resptr_r
	j	ra

	.end	RTNNAME

